import { Converter } from "univ-conv";
import { AbstractEntry } from "./AbstractEntry";
import { AbstractFileSystem } from "./AbstractFileSystem";
import { AbstractReadStream } from "./AbstractReadStream";
import { AbstractWriteStream } from "./AbstractWriteStream";
import { DeleteOptions, ErrorLike, File, OpenOptions, OpenReadOptions, OpenWriteOptions, ReadStream, Source, SourceType, WriteStream, XmitOptions } from "./core";
export declare abstract class AbstractFile extends AbstractEntry implements File {
    private beforeGet?;
    private beforePost?;
    private beforePut?;
    constructor(fs: AbstractFileSystem, path: string);
    _convert(converter: Converter, chunk: Source, type: SourceType): Promise<Source>;
    _delete(options: DeleteOptions, _errors: ErrorLike[]): Promise<void>;
    _joinChunks(chunks: Source[], length: number, type: SourceType): Promise<Source>;
    _xmit(toEntry: AbstractEntry, _copyErrors: ErrorLike[], options: XmitOptions): Promise<void>;
    createReadStream(options?: OpenOptions): Promise<ReadStream>;
    createWriteStream(options?: OpenWriteOptions): Promise<WriteStream>;
    hash(options?: OpenOptions): Promise<string>;
    readAll(options?: OpenReadOptions): Promise<Source>;
    writeAll(src: Source, options?: OpenWriteOptions): Promise<number>;
    abstract _createReadStream(options: OpenOptions): Promise<AbstractReadStream>;
    abstract _createWriteStream(options: OpenWriteOptions): Promise<AbstractWriteStream>;
    abstract _rm(): Promise<void>;
    protected _createBuffer(byteLength: number): Uint8Array;
}
//# sourceMappingURL=AbstractFile.d.ts.map