import { AbstractFile } from "./AbstractFile";
import { AbstractStream } from "./AbstractStream";
import { OpenReadOptions, ReadStream, Source, SourceType, WriteStream } from "./core";
export declare abstract class AbstractReadStream extends AbstractStream implements ReadStream {
    protected readonly options: OpenReadOptions;
    private afterGet?;
    protected fileSize?: number;
    protected handled: boolean;
    constructor(file: AbstractFile, options: OpenReadOptions);
    close(): Promise<void>;
    pipe(ws: WriteStream): Promise<void>;
    read(size?: number): Promise<Source | null>;
    abstract _close(): Promise<void>;
    abstract _read(size?: number): Promise<Source | null>;
    protected _getFileSize(): Promise<number>;
    protected abstract getDefaultSourceType(): SourceType;
}
//# sourceMappingURL=AbstractReadStream.d.ts.map