"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AbstractStream = void 0;
var tslib_1 = require("tslib");
var univ_conv_1 = require("univ-conv");
var core_1 = require("./core");
var AbstractStream = (function () {
    function AbstractStream(file, options) {
        this.file = file;
        this.bufferSize = core_1.DEFAULT_BUFFER_SIZE;
        this.position = 0;
        (0, univ_conv_1.validateBufferSize)(options);
        this.converter = new univ_conv_1.Converter({ bufferSize: options.bufferSize });
    }
    AbstractStream.prototype.seek = function (offset, origin) {
        return (0, tslib_1.__awaiter)(this, void 0, void 0, function () {
            var stats, size, start;
            return (0, tslib_1.__generator)(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.file.head()];
                    case 1:
                        stats = _a.sent();
                        size = stats.size;
                        if (origin === core_1.SeekOrigin.Begin) {
                            start = offset;
                        }
                        else if (origin === core_1.SeekOrigin.Current) {
                            start = this.position + offset;
                        }
                        else {
                            start = size + offset;
                        }
                        if (start < 0) {
                            start = 0;
                        }
                        else if (size < start) {
                            start = size;
                        }
                        this.position = start;
                        return [4, this._seek(start)];
                    case 2:
                        _a.sent();
                        return [2];
                }
            });
        });
    };
    return AbstractStream;
}());
exports.AbstractStream = AbstractStream;
//# sourceMappingURL=AbstractStream.js.map