"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AbstractWriteStream = void 0;
var tslib_1 = require("tslib");
var AbstractStream_1 = require("./AbstractStream");
var AbstractWriteStream = (function (_super) {
    (0, tslib_1.__extends)(AbstractWriteStream, _super);
    function AbstractWriteStream(file, options) {
        var _this = _super.call(this, file, options) || this;
        _this.options = options;
        _this.changed = false;
        var hook = file.fs.options.hook;
        _this.afterPost = hook === null || hook === void 0 ? void 0 : hook.afterPost;
        _this.afterPut = hook === null || hook === void 0 ? void 0 : hook.afterPut;
        return _this;
    }
    AbstractWriteStream.prototype.close = function () {
        return (0, tslib_1.__awaiter)(this, void 0, void 0, function () {
            return (0, tslib_1.__generator)(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this._close()];
                    case 1:
                        _a.sent();
                        this.position = 0;
                        if (!this.changed) {
                            return [2];
                        }
                        if (!(!this.options.ignoreHook && this.afterPost && this.options.create)) return [3, 3];
                        return [4, this.afterPost(this.file.path)];
                    case 2:
                        _a.sent();
                        return [3, 5];
                    case 3:
                        if (!(!this.options.ignoreHook &&
                            this.afterPut &&
                            !this.options.create)) return [3, 5];
                        return [4, this.afterPut(this.file.path)];
                    case 4:
                        _a.sent();
                        _a.label = 5;
                    case 5: return [2];
                }
            });
        });
    };
    AbstractWriteStream.prototype.truncate = function (size) {
        return (0, tslib_1.__awaiter)(this, void 0, void 0, function () {
            return (0, tslib_1.__generator)(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this._truncate(size)];
                    case 1:
                        _a.sent();
                        if (size < this.position) {
                            this.position = size;
                        }
                        this.changed = true;
                        return [2];
                }
            });
        });
    };
    AbstractWriteStream.prototype.write = function (src) {
        return (0, tslib_1.__awaiter)(this, void 0, void 0, function () {
            var written;
            return (0, tslib_1.__generator)(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this._write(src)];
                    case 1:
                        written = _a.sent();
                        this.position += written;
                        this.changed = true;
                        return [2, written];
                }
            });
        });
    };
    return AbstractWriteStream;
}(AbstractStream_1.AbstractStream));
exports.AbstractWriteStream = AbstractWriteStream;
//# sourceMappingURL=AbstractWriteStream.js.map